#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <time.h>
#include <signal.h>
#include <errno.h>

#include "utils.c"

#ifdef LINUX
#include <mysql.h>

#else
#include "/usr/include/mysql/mysql.h"
#endif

#define MYSQL_HOST   "localhost"       // database server name
#define MYSQL_DB     "syslog"        // database name
#define MYSQL_USERID "root"          // database user id
#define MYSQL_PASSWD ""        // userid password

int main() {

  MYSQL mysql;
  MYSQL_RES *result;
  MYSQL_ROW row;

  unsigned int num_fields;
  int  record_count;

  char query_str[1000];
  time_t curtime;
  struct tm *loctime;

char cmdline[100000];

char *baff;
char buffer[500000];
char chr_now[256];

#ifndef LINUX
  mysql_init(&mysql);
#endif

  if (!mysql_connect(&mysql,MYSQL_HOST,MYSQL_USERID,MYSQL_PASSWD))
  {
    printf("Failed to connect to database: Error: %s\n",mysql_error(&mysql));
    return 0;
  }

  if (mysql_select_db(&mysql,MYSQL_DB)) {
    printf("Failed to select table: Error: %s\n",mysql_error(&mysql));
    mysql_close(&mysql);
    return 0;
  }


while(1)
{

curtime = time (NULL);
loctime = localtime (&curtime);

strftime (chr_now, 256, "%Y%m%d%H%M%S", loctime);

  strcpy(query_str,"SELECT * FROM tab4 WHERE TS<");
  strcat(query_str,chr_now);
  mysql_query(&mysql,query_str);
  result = mysql_use_result(&mysql);

num_fields = 1;

  while ((row = mysql_fetch_row(result)))
  {
    unsigned long *lengths = mysql_fetch_lengths(result);


        baff=((int) lengths[1], row[1] ? row[1] : "");
        strcat(buffer,"HOST:");
        strcat(buffer, baff);
        baff=((int) lengths[2], row[2] ? row[2] : "");
        strcat(buffer," TS:");
        strcat(buffer, baff);
        baff=((int) lengths[3], row[3] ? row[3] : "");
        strcat(buffer," LEVEL:");
        strcat(buffer, baff);
        baff=((int) lengths[4], row[4] ? row[4] : "");
	strcat(buffer," MODULE:");
        strcat(buffer, baff);
        baff=((int) lengths[5], row[5] ? row[5] : "");
        strcat(buffer," MESSAGE:");
        strcat(buffer, baff);
        strcat(buffer," \n");

	num_fields++;

  }


if(num_fields>1)
{


  sprintf(cmdline,"echo '%s'|/bin/mail -s 'Warning Messages' mj@globalremote.com", buffer);
  my_system(cmdline);

  mysql_free_result(result);

  strcpy(query_str,"DELETE FROM tab4 WHERE TS<'");
  strcat(query_str,chr_now);
  strcat(query_str,"'");

  mysql_query(&mysql,query_str);
}

sleep(10);
}

mysql_close(&mysql);

}
